//---------------------------------------------------------------------------
//
// Name:        GroundEditorFrm.cpp
// Author:      i-saint
// Created:     2005/04/19 8:12:12
//
//---------------------------------------------------------------------------

#include "GroundEditorApp.h"
#include "GroundEditorFrm.h"
#include "ResizeDlg.h"
#include "ScaleDlg.h"
#include "UVRangeDlg.h"
#include "SaveAsTextureDlg.h"
#include "canvas.h"

//Do not add custom headers.
//wx-dvcpp designer will remove them
////Header Include Start
////Header Include End




//----------------------------------------------------------------------------
// GroundEditorFrm
//----------------------------------------------------------------------------
   //Add Custom Events only in the appropriate Block.
   // Code added in  other places will be removed by wx-dvcpp 
  ////Event Table Start
BEGIN_EVENT_TABLE(GroundEditorFrm,wxFrame)
	////Manual Code Start
	EVT_COMBOBOX(ID_CBBRUSHTYPE, GroundEditorFrm::CBBrushTypeCombo)
	////Manual Code End
	
	EVT_CLOSE(GroundEditorFrm::GroundEditorFrmClose)
	EVT_PAINT(GroundEditorFrm::GroundEditorFrmPaint)
	EVT_IDLE(GroundEditorFrm::GroundEditorFrmIdle)
	EVT_MENU(wxID_OPEN , GroundEditorFrm::WxopenClick)
	EVT_MENU(wxID_SAVE , GroundEditorFrm::WxsaveClick)
	EVT_MENU(wxID_SAVEAS , GroundEditorFrm::WxsaveasClick)
	EVT_MENU(ID_MNU_SAVEASTEXTURE_1112 , GroundEditorFrm::MNSaveAsTextureClick)
	EVT_MENU(ID_MNU_Canvas_1081 , GroundEditorFrm::MNCanvasClick)
	EVT_MENU(ID_MNU_SCALE_1083 , GroundEditorFrm::MNScaleClick)
	EVT_MENU(ID_MNU_SUBMENUITEM9_1085 , GroundEditorFrm::MNUVRangeClick)
	EVT_COMMAND_SCROLL(ID_SLCAMERA,GroundEditorFrm::SLCameraScroll)
	EVT_BUTTON(ID_BUTEXHEIGHT,GroundEditorFrm::BUTexHeightClick)
	EVT_BUTTON(ID_BUTEXSQUARE,GroundEditorFrm::BUTexSquareClick)
	EVT_BUTTON(ID_BUTEXTURE,GroundEditorFrm::BUTextureClick)
	EVT_CHECKBOX(ID_CKGTEXTURE,GroundEditorFrm::CKGTextureClick)
	EVT_CHECKBOX(ID_CHKLIGHTING,GroundEditorFrm::CHKLightingClick)
	EVT_CHECKBOX(ID_CHKPOINT,GroundEditorFrm::CHKPointClick)
	EVT_CHECKBOX(ID_CHKLINE,GroundEditorFrm::CHKLineClick)
	EVT_CHECKBOX(ID_CHKPOLYGON,GroundEditorFrm::CHKPolygonClick)
	EVT_RADIOBUTTON(ID_RBUVV,GroundEditorFrm::RBUVVClick)
	EVT_RADIOBUTTON(ID_RBUVU,GroundEditorFrm::RBUVUClick)
	
	EVT_TEXT(ID_SPATTR,GroundEditorFrm::SPAttrUpdated)
	EVT_CHECKBOX(ID_CKAUTOUV,GroundEditorFrm::CKAutoUVClick)
	EVT_RADIOBUTTON(ID_RBFLAT,GroundEditorFrm::RBFlatClick)
	EVT_RADIOBUTTON(ID_RBDOWN,GroundEditorFrm::RBDownClick)
	EVT_RADIOBUTTON(ID_RBUP,GroundEditorFrm::RBUpClick)
	EVT_COMMAND_SCROLL(ID_SLSTRENGTH,GroundEditorFrm::SLStrengthScroll)
	EVT_COMMAND_SCROLL(ID_SLWIDTH,GroundEditorFrm::SLWidthScroll)
END_EVENT_TABLE()
  ////Event Table End



GroundEditorFrm::GroundEditorFrm( wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style )
    : wxFrame( parent, id, title, position, size, style)
{
	::wxInitAllImageHandlers();
	CreateGUIControls();
	CreateGLWidgets();
	SLCamera->SetValue(500);
	SLWidth->SetValue(75);
	SLStrength->SetValue(40);
	RBUVV->SetValue(true);
}

GroundEditorFrm::~GroundEditorFrm() {} 

void GroundEditorFrm::CreateGUIControls(void)
{
    //Do not add custom Code here
    //wx-devcpp designer will remove them.
    //Add the custom code before or after the Blocks
    ////GUI Items Creation Start

	WxStatusBar1 =  new wxStatusBar(this, ID_WXSTATUSBAR1 );

	WxPanel1 =  new wxPanel(this, ID_WXPANEL1, wxPoint(0,0),wxSize(832,512) );
	WxPanel1->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	ground_panel =  new wxPanel(WxPanel1, ID_GROUND_PANEL, wxPoint(5,5),wxSize(640,480) );
	ground_panel->SetBackgroundColour(wxColour(*wxBLACK));
	ground_panel->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	minimap_panel =  new wxPanel(WxPanel1, ID_MINIMAP_PANEL, wxPoint(672,355),wxSize(130,130) );
	minimap_panel->SetBackgroundColour(wxColour(*wxBLACK));
	minimap_panel->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxNotebook1 =  new wxNotebook(WxPanel1, ID_VIEW, wxPoint(648,0),wxSize(177,321) );
	WxNotebook1->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxNoteBookPage1 =  new wxPanel(WxNotebook1, ID_WXNOTEBOOKPAGE1,wxPoint(4,24),wxSize(169,293) );
	WxNoteBookPage1->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));
	WxNotebook1->AddPage(WxNoteBookPage1,_("edit"));

	SBBrush =  new wxStaticBox(WxNoteBookPage1, ID_SBBRUSH,_("brush"),wxPoint(4,32),wxSize(161,257)  );
	SBBrush->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxStaticText3 =  new wxStaticText(WxNoteBookPage1, ID_WXSTATICTEXT3 ,_("width") ,wxPoint(20,56),wxSize(29,17)  );
	WxStaticText3->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxStaticText4 =  new wxStaticText(WxNoteBookPage1, ID_WXSTATICTEXT4 ,_("stlength") ,wxPoint(12,80),wxSize(41,17)  );
	WxStaticText4->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	SLWidth =  new wxSlider(WxNoteBookPage1, ID_SLWIDTH,0,0,300,wxPoint(52,48),wxSize(110,23)  , wxSL_HORIZONTAL);
	SLWidth->SetRange(0,300);
	SLWidth->SetValue(0);
	SLWidth->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	SLStrength =  new wxSlider(WxNoteBookPage1, ID_SLSTRENGTH,0,0,150,wxPoint(52,72),wxSize(110,23)  , wxSL_HORIZONTAL);
	SLStrength->SetRange(0,150);
	SLStrength->SetValue(0);
	SLStrength->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	RBUp =  new wxRadioButton(WxNoteBookPage1, ID_RBUP ,_("up") ,wxPoint(12,104),wxSize(41,17)  , wxRB_GROUP);
	RBUp->SetValue(true);
	RBUp->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	RBDown =  new wxRadioButton(WxNoteBookPage1, ID_RBDOWN ,_("down") ,wxPoint(60,104),wxSize(49,17) );
	RBDown->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	RBFlat =  new wxRadioButton(WxNoteBookPage1, ID_RBFLAT ,_("flat") ,wxPoint(116,104),wxSize(41,17) );
	RBFlat->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	CKAutoUV =  new wxCheckBox(WxNoteBookPage1, ID_CKAUTOUV, _("autoUV") , wxPoint(12,152),wxSize(65,17) );
	CKAutoUV->SetValue(true);
	CKAutoUV->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	wxArrayString arrayStringFor_CBBrushType;
	arrayStringFor_CBBrushType.Add(_("height"));
	arrayStringFor_CBBrushType.Add(_("UV"));
	arrayStringFor_CBBrushType.Add(_("attribute"));
	CBBrushType =  new wxComboBox(WxNoteBookPage1, ID_CBBRUSHTYPE ,_("height") ,wxPoint(76,8),wxSize(81,21), arrayStringFor_CBBrushType   , wxCB_READONLY );
	CBBrushType->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxStaticText1 =  new wxStaticText(WxNoteBookPage1, ID_WXSTATICTEXT1 ,_("edit mode") ,wxPoint(20,8),wxSize(50,17)  );
	WxStaticText1->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	SPAttr =  new wxSpinCtrl(WxNoteBookPage1, ID_SPATTR ,"1" ,wxPoint(12,248),wxSize(49,22) , wxSP_ARROW_KEYS  ,0,31,1);
	SPAttr->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxStaticText2 =  new wxStaticText(WxNoteBookPage1, ID_WXSTATICTEXT2 ,_("attribute option") ,wxPoint(12,232),wxSize(74,17)  );
	WxStaticText2->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxStaticText5 =  new wxStaticText(WxNoteBookPage1, ID_WXSTATICTEXT5 ,_("height option") ,wxPoint(12,136),wxSize(65,17)  );
	WxStaticText5->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxStaticText7 =  new wxStaticText(WxNoteBookPage1, ID_WXSTATICTEXT7 ,_("UV option") ,wxPoint(12,184),wxSize(51,17)  );
	WxStaticText7->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	RBUVU =  new wxRadioButton(WxNoteBookPage1, ID_RBUVU ,_("u") ,wxPoint(12,200),wxSize(33,17)  , wxRB_GROUP);
	RBUVU->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	RBUVV =  new wxRadioButton(WxNoteBookPage1, ID_RBUVV ,_("v") ,wxPoint(52,200),wxSize(33,17) );
	RBUVV->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxStaticLine1 =  new wxStaticLine(WxNoteBookPage1, ID_WXSTATICLINE1, wxPoint(12,122),wxSize(145,2) );
	WxStaticLine1->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxStaticLine2 =  new wxStaticLine(WxNoteBookPage1, ID_WXSTATICLINE2, wxPoint(12,170),wxSize(145,2) );
	WxStaticLine2->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxStaticLine3 =  new wxStaticLine(WxNoteBookPage1, ID_WXSTATICLINE3, wxPoint(12,218),wxSize(145,2) );
	WxStaticLine3->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxNoteBookPage3 =  new wxPanel(WxNotebook1, ID_WXNOTEBOOKPAGE3,wxPoint(4,24),wxSize(169,293) );
	WxNoteBookPage3->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));
	WxNotebook1->AddPage(WxNoteBookPage3,_("view"));

	draw =  new wxStaticBox(WxNoteBookPage3, ID_DRAW,_("draw mode"),wxPoint(4,0),wxSize(161,193)  );
	draw->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	CHKPolygon =  new wxCheckBox(WxNoteBookPage3, ID_CHKPOLYGON, _("polygon") , wxPoint(12,56),wxSize(65,17) );
	CHKPolygon->SetValue(true);
	CHKPolygon->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	CHKLine =  new wxCheckBox(WxNoteBookPage3, ID_CHKLINE, _("line") , wxPoint(12,40),wxSize(41,17) );
	CHKLine->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	CHKPoint =  new wxCheckBox(WxNoteBookPage3, ID_CHKPOINT, _("point") , wxPoint(12,24),wxSize(49,17) );
	CHKPoint->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	CHKLighting =  new wxCheckBox(WxNoteBookPage3, ID_CHKLIGHTING, _("lighting") , wxPoint(12,80),wxSize(65,17) );
	CHKLighting->SetValue(true);
	CHKLighting->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	CKGTexture =  new wxCheckBox(WxNoteBookPage3, ID_CKGTEXTURE, _("texture") , wxPoint(12,104),wxSize(57,17) );
	CKGTexture->SetValue(true);
	CKGTexture->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	BUTexture =  new wxButton(WxNoteBookPage3, ID_BUTEXTURE, _("select") , wxPoint(76,104),wxSize(51,25) );
	BUTexture->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxStaticText6 =  new wxStaticText(WxNoteBookPage3, ID_WXSTATICTEXT6 ,_("texcoord") ,wxPoint(12,136),wxSize(45,17)  );
	WxStaticText6->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	BUTexSquare =  new wxButton(WxNoteBookPage3, ID_BUTEXSQUARE, _("square") , wxPoint(12,152),wxSize(49,25) );
	BUTexSquare->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	BUTexHeight =  new wxButton(WxNoteBookPage3, ID_BUTEXHEIGHT, _("height") , wxPoint(64,152),wxSize(49,25) );
	BUTexHeight->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	SLCamera =  new wxSlider(WxPanel1, ID_SLCAMERA,0,0,1500,wxPoint(664,328),wxSize(150,23)  , wxSL_HORIZONTAL);
	SLCamera->SetRange(0,1500);
	SLCamera->SetValue(0);
	SLCamera->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxMenuBar1 =  new wxMenuBar( );
	wxMenu *wxID_FILE1_Mnu_Obj = new wxMenu(0);
	WxMenuBar1->Append(wxID_FILE1_Mnu_Obj,_("&File"));
	
	wxID_FILE1_Mnu_Obj->Append(wxID_OPEN,_("&Open\tCtrl+O"),_(""), wxITEM_NORMAL);
	
	wxID_FILE1_Mnu_Obj->Append(wxID_SAVE,_("&Save\tCtrl+S"),_(""), wxITEM_NORMAL);
	
	wxID_FILE1_Mnu_Obj->Append(wxID_SAVEAS,_("Save &As\tShift+Ctrl+S"),_(""), wxITEM_NORMAL);
	
	wxID_FILE1_Mnu_Obj->Append(ID_MNU_SAVEASTEXTURE_1112,_("Save As Texture\tCtrl+T"),_(""), wxITEM_NORMAL);
	
	wxMenu *ID_MNU_EDIT_1080_Mnu_Obj = new wxMenu(0);
	WxMenuBar1->Append(ID_MNU_EDIT_1080_Mnu_Obj,_("&Edit"));
	
	ID_MNU_EDIT_1080_Mnu_Obj->Append(ID_MNU_Canvas_1081,_("Canvas Size\tC"),_(""), wxITEM_NORMAL);
	
	ID_MNU_EDIT_1080_Mnu_Obj->Append(ID_MNU_SCALE_1083,_("Scale\tS"),_(""), wxITEM_NORMAL);
	
	ID_MNU_EDIT_1080_Mnu_Obj->Append(ID_MNU_SUBMENUITEM9_1085,_("UV Range\tR"),_(""), wxITEM_NORMAL);
	
	
	this->SetMenuBar(WxMenuBar1);

	this->SetStatusBar(WxStatusBar1);
	this->SetSize(8,8,840,560);
	this->SetTitle(_("GroundEditor"));
	this->Center();
	this->SetIcon(wxNullIcon);
	
    ////GUI Items Creation End
}

void GroundEditorFrm::GroundEditorFrmClose(wxCloseEvent& event)
{
    // --> Don't use Close with a Frame,
    // use Destroy instead.
    Destroy();
}
 




void GroundEditorFrm::CreateGLWidgets()
{
	int attr[] = {
		WX_GL_RGBA,
		WX_GL_DOUBLEBUFFER,
		WX_GL_MIN_RED, 5,
		WX_GL_MIN_GREEN, 5,
		WX_GL_MIN_BLUE, 5,
		WX_GL_DEPTH_SIZE, 16};

	ground_canvas = new GroundCanvas(this, ground_panel, ID_GROUND_CANVAS,
		wxPoint(0,0), ground_panel->GetSize(), 0, _T("GLGroundCanvas"), attr);

	minimap_canvas = new MinimapCanvas(this, minimap_panel, ground_canvas->GetContext(), ID_MINIMAP_CANVAS,
		wxPoint(0,0), minimap_panel->GetSize(), 0, _T("GLMinimapCanvas"), attr);

	ground_canvas->SetCurrent();
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glShadeModel( GL_SMOOTH );
	glCullFace( GL_BACK );
	glFrontFace( GL_CCW );
	glEnable( GL_CULL_FACE );
	glEnable( GL_BLEND );
	glEnable( GL_DEPTH_TEST );
	glClearColor( 0, 0, 0, 0);
	GetGEApp().loadGTexture("height.png");
}

void GroundEditorFrm::Draw()
{
	static bool is_first=true;
	if(is_first) {
		is_first=false;
		ground_canvas->SetCurrent();
		GetGEApp().loadGTexture("height.png");
	}
	{
		ground_canvas->SetCurrent();
		GetGEApp().drawGround();
		GetBrush().draw();
		ground_canvas->SwapBuffers();
	}
	{
		minimap_canvas->SetCurrent();
		GetGEApp().drawMinimap();
		minimap_canvas->SwapBuffers();
	}
}


bool GroundEditorFrm::Open()
{
	wxFileDialog file_dlg(this, _T("open"), _T(""), _T(""),
		_T("all|*.hgt;*.bmp;*.tga;*.png;*.jpg;*.gif|height file (*.hgt)|*.hgt"),
		wxOPEN | wxFILE_MUST_EXIST );

	bool succeded=false;
	if(file_dlg.ShowModal()==wxID_OK) {
		wxImage img;
		if(img.LoadFile(file_dlg.GetPath())) {
			ist::Bitmap bmp(img.GetWidth(), img.GetHeight());
			for(int i=0; i<img.GetHeight(); ++i) {
				for(int j=0; j<img.GetWidth(); ++j) {
					bmp[i][j].r = img.GetRed(j, i);
					bmp[i][j].g = img.GetGreen(j, i);
					bmp[i][j].b = img.GetBlue(j, i);
					bmp[i][j].a = img.GetAlpha(j, i);
				}
			}
			GetGEApp().load(bmp);
			succeded=true;
		}
		else if(GetGEApp().load(file_dlg.GetPath().c_str())) {
			succeded=true;
		}
		if(succeded) {
			filename = file_dlg.GetPath();
			minimap_canvas->SetCurrent();
			GetGEApp().updateMinimap();
		}
	}
	return succeded;
}

bool GroundEditorFrm::Save()
{
	std::string stdfn(filename.c_str());
	if(!filename.empty() && filename.rfind(".hgt")!=std::string::npos)
		return GetGEApp().save(stdfn);
	else
		return SaveAs();
	return false;
}

bool GroundEditorFrm::SaveAs()
{
	wxFileDialog file_dlg(this, _T("save"), _T(""), _T(""),
		_T("height file (*.hgt)|*.hgt|mqo file (*.mqo)|*.mqo|obj file (*.obj)|*.obj|png file (*.png)|*.png"),
		wxSAVE | wxOVERWRITE_PROMPT );
	if(file_dlg.ShowModal()==wxID_OK) {
		filename = file_dlg.GetPath();
		return GetGEApp().save(filename.c_str());
	}
	return false;
}




void GroundEditorFrm::GroundCanvasMouse(wxMouseEvent& event)
{
	if(!ground_panel)
		return;

	wxSize size=ground_panel->GetSize();
	bool move_top=false, move_bottom=false, move_right=false, move_left=false;

	int border=20;
	if(event.GetX()<border)
		move_right=true;
	else if(event.GetX()>size.GetWidth()-border)
		move_left=true;
	if(event.GetY()<border)
		move_top=true;
	else if(event.GetY()>size.GetHeight()-border)
		move_bottom=true;

	float camera_speed = 10.0f;
	ist::vector4 vertical = GetGEApp().getCamera().position-GetGEApp().getCamera().target;
	vertical.y=0.0f;
	vertical.normalize();
	vertical*=camera_speed;
	ist::vector4 horisontal = ist::matrix44().rotateY(90)*vertical;
	if(move_top)   { GetGEApp().moveCamera(-vertical); }
	if(move_bottom){ GetGEApp().moveCamera(vertical); }
	if(move_right) { GetGEApp().moveCamera(-horisontal); }
	if(move_left)  { GetGEApp().moveCamera(horisontal); }



	ground_canvas->SetCurrent();
	ist::vector4 mpos = GetGEApp().getRayCross(event.GetX(), event.GetY());
	{
		GetBrush().setPos(mpos);
		wxString tmp;
		tmp.Printf("(%.1f, %.1f, %.1f)", mpos.x, mpos.y, mpos.z);
		SetStatusText(tmp);
	}
	if(event.LeftDown()) {
		GetBrush().setFlatHeight();
	}
	if(event.LeftIsDown()) {
		GetBrush().execute();
	}
	if(event.LeftUp()) {
		minimap_canvas->SetCurrent();
		GetGEApp().updateMinimap();
	}


	event.Skip();
}

void GroundEditorFrm::MinimapCanvasMouse(wxMouseEvent& event)
{
	if(event.LeftIsDown()) {
		int x = event.GetX();
		int y = event.GetY();
		if(GetMinimap().isMouseOver(x, y)) {
			ist::vector2 m = GetMinimap().getMousePointerPos(x, y);
			GetGEApp().setCameraPos(ist::vector4(m.x, 0, m.y));
		}
	}
	event.Skip();
}

void GroundEditorFrm::CBBrushTypeCombo(wxCommandEvent& event) {
	if(event.GetString()==_T("height"))
		GetBrush().setBrushType(EDIT_HEIGHT);
	else if(event.GetString()==_T("UV"))
		GetBrush().setBrushType(EDIT_UV);
	else if(event.GetString()==_T("attribute"))
		GetBrush().setBrushType(EDIT_ATTR);
	event.Skip();
}



/*
 * RBUpClick
 */
void GroundEditorFrm::RBUpClick(wxCommandEvent&)
{
	// insert your code here
	GetBrush().setEditMode(EDIT_UP);
}

/*
 * RBDownClick
 */
void GroundEditorFrm::RBDownClick(wxCommandEvent&)
{
	// insert your code here
	GetBrush().setEditMode(EDIT_DOWN);
}

/*
 * RBFlatClick
 */
void GroundEditorFrm::RBFlatClick(wxCommandEvent&)
{
	// insert your code here
	GetBrush().setEditMode(EDIT_FLAT);
}

/*
 * SLWidthScroll
 */
void GroundEditorFrm::SLWidthScroll(wxScrollEvent& event)
{
	// insert your code here
	GetBrush().setRadius(float(event.GetInt()));
	event.Skip();
}

/*
 * SLStrengthScroll
 */
void GroundEditorFrm::SLStrengthScroll(wxScrollEvent& event)
{
	// insert your code here
	GetBrush().setStrength(float(event.GetInt())/10.0f);
	event.Skip();
}


/*
 * WxopenClick
 */
void GroundEditorFrm::WxopenClick(wxCommandEvent& event)
{
	// insert your code here
	Open();
	event.Skip();
}

/*
 * WxsaveClick
 */
void GroundEditorFrm::WxsaveClick(wxCommandEvent& event)
{
	// insert your code here
	Save();
	event.Skip();
}

/*
 * WxsaveasClick
 */
void GroundEditorFrm::WxsaveasClick(wxCommandEvent& event)
{
	// insert your code here
	SaveAs();
	event.Skip();
}

/*
 * CHKPointClick
 */
void GroundEditorFrm::CHKPointClick(wxCommandEvent& event)
{
	// insert your code here
	GetGEApp().setDrawPoint(event.IsChecked());
	event.Skip();
}

/*
 * CHKLineClick
 */
void GroundEditorFrm::CHKLineClick(wxCommandEvent& event)
{
	// insert your code here
	GetGEApp().setDrawLine(event.IsChecked());
	event.Skip();
}

/*
 * CHKPolygonClick
 */
void GroundEditorFrm::CHKPolygonClick(wxCommandEvent& event)
{
	// insert your code here
	GetGEApp().setDrawPolygon(event.IsChecked());
	event.Skip();
}

/*
 * CHKLightingClick
 */
void GroundEditorFrm::CHKLightingClick(wxCommandEvent& event)
{
	// insert your code here
	GetGEApp().setLighting(event.IsChecked());
	event.Skip();
}



/*
 * GroundEditorFrmIdle
 */
void GroundEditorFrm::GroundEditorFrmIdle(wxIdleEvent& event)
{
	// insert your code here
	Draw();
	event.Skip();
}

/*
 * GroundEditorFrmPaint
 */
void GroundEditorFrm::GroundEditorFrmPaint(wxPaintEvent& event)
{
	// insert your code here
	wxPaintDC(this);
	Draw();
	event.Skip();
}

/*
 * CKGTextureClick
 */
void GroundEditorFrm::CKGTextureClick(wxCommandEvent& event)
{
	// insert your code here
	GetGEApp().enableGTexture(event.IsChecked());
	event.Skip();
}

/*
 * BUTextureClick
 */
void GroundEditorFrm::BUTextureClick(wxCommandEvent& event)
{
	// insert your code here
	wxFileDialog file_dlg(this, _T("open texture"), _T(""), _T(""), _T("bitmap file (*.bmp *.png *.tga)|*.bmp;*.png;*.tga"),
		wxOPEN | wxFILE_MUST_EXIST);
	if(file_dlg.ShowModal()==wxID_OK) {
		ground_canvas->SetCurrent();
		GetGEApp().loadGTexture(file_dlg.GetPath().c_str());
	}
	event.Skip();
}

/*
 * BUTexSquareClick
 */
void GroundEditorFrm::BUTexSquareClick(wxCommandEvent& event)
{
	// insert your code here
	GetGround().setSquareTexcoord();
	event.Skip();
}

/*
 * BUTexHeightClick
 */
void GroundEditorFrm::BUTexHeightClick(wxCommandEvent& event)
{
	// insert your code here
	GetGround().setHeightTexcoord();
	event.Skip();
}

/*
 * Mnuresize1081Click
 */
void GroundEditorFrm::MNCanvasClick(wxCommandEvent& event)
{
	// insert your code here
	ResizeDlg dlg(this);
	dlg.ShowModal();

	minimap_canvas->SetCurrent();
	GetGEApp().updateMinimap();

	event.Skip();
}

/*
 * Mnuyscale1083Click
 */
void GroundEditorFrm::MNScaleClick(wxCommandEvent& event)
{
	// insert your code here
	ScaleDlg dlg(this);
	dlg.ShowModal();

	event.Skip();
}

/*
 * MNTCoordRange
 */
void GroundEditorFrm::MNUVRangeClick(wxCommandEvent& event)
{
	// insert your code here
	UVRangeDlg dlg(this);
	dlg.ShowModal();

	event.Skip();
}

/*
 * SLCameraScroll
 */
void GroundEditorFrm::SLCameraScroll(wxScrollEvent& event)
{
	// insert your code here
	GetGEApp().setCameraFloating(300.f+event.GetInt());
	event.Skip();
}

/*
 * CKAutoUVClick
 */
void GroundEditorFrm::CKAutoUVClick(wxCommandEvent& event)
{
	// insert your code here
	GetBrush().setAutoUV(event.IsChecked());
	event.Skip();
}

/*
 * SPAttrUpdated
 */
void GroundEditorFrm::SPAttrUpdated(wxCommandEvent& event )
{
	// insert your code here
	GetBrush().setAttr(event.GetInt());
	event.Skip();
}

/*
 * RBUVUClick
 */
void GroundEditorFrm::RBUVUClick(wxCommandEvent& event)
{
	// insert your code here
	GetBrush().setEditU(true);
	event.Skip();
}

/*
 * RBUVVClick
 */
void GroundEditorFrm::RBUVVClick(wxCommandEvent& event)
{
	// insert your code here
	GetBrush().setEditU(false);
	event.Skip();
}


/*
 * GroundEditorFrmKeyDown
 */
void GroundEditorFrm::GroundEditorFrmKeyDown(wxKeyEvent& event)
{
	// insert your code here
//	event.Skip();
}

/*
 * MNSaveAsTextureClick
 */
void GroundEditorFrm::MNSaveAsTextureClick(wxCommandEvent& event)
{
	// insert your code here
	ground_canvas->SetCurrent();
	SaveAsTextureDlg dlg(this);
	dlg.SetCanvas(ground_canvas);
	dlg.ShowModal();

	event.Skip();
}
