#!/bin/sh

target=libist.a
CXX=g++
CFLAGS="-s -O2 `sdl-config --cflags` -DUSE_SDL -DUSE_PNG"


if test $# -ne 0
then
	srcs=`echo $@ | grep -E \.\(cc\|cpp\)`
else
	srcs=`ls | grep -E \.\(cc\|cpp\)`
fi

for f in ${srcs}
do
	echo $f
	${CXX} -c ${CFLAGS} ${f}
done

objs=`echo $srcs | sed -r s/\.\(cc\|cpp\)/\.o/g`

echo $target
ar -r ${target} ${objs}

