#ifndef IST_GL_ANIMATED_POLYGON
#define IST_GL_ANIMATED_POLYGON

#include "ist/gl_include.h"
#include "animated_polygon.h"

namespace ist {
namespace i3d {

class AnimatedModel : public BAnimatedModel
{
public:
	AnimatedModel() {}
	AnimatedModel(const std::string& filename) { load(filename); }
	void draw(const std::string& c, float t) const { BAnimatedModel::draw(c, t); }
	void draw(iterator p, float t) const;
};

class CachedAnimatedModel : public BCachedAnimatedModel
{
public:
	CachedAnimatedModel() {}
	CachedAnimatedModel(const std::string& filename, bool en=true) { enableNormal(en); load(filename); }
	void draw(const std::string& c, int t) const { BCachedAnimatedModel::draw(c, t); }
	void draw(iterator p, int t) const;
};

} // gl
} // ist

#endif
