#include "gl_info.h"

namespace ist {
namespace i3d {


void Info::print(std::ostream& out) {
	out << "GL_VERSION:  " << glGetString(GL_VERSION) << std::endl;
	out << "GL_RENDERER: " << glGetString(GL_RENDERER) << std::endl;
	out << "GL_VENDOR:   " << glGetString(GL_VENDOR) << std::endl;

	out << std::endl;
	out << "GL_EXTENSIONS:" << std::endl;
	for(const GLubyte *ext = glGetString(GL_EXTENSIONS); *ext!='\0'; ++ext) {
		if(*ext==' ')
			out << std::endl;
		else
			out << *ext;
	}

	out << std::endl;
	int v[2];
	float fv[2];
	glGetIntegerv(GL_MAX_ATTRIB_STACK_DEPTH, v);
	out << "GL_MAX_ATTRIB_STACK_DEPTH:     " << v[0] << std::endl;

	glGetIntegerv(GL_MAX_CLIP_PLANES, v);
	out << "GL_MAX_CLIP_PLANES:            " << v[0] << std::endl;

	glGetIntegerv(GL_MAX_EVAL_ORDER, v);
	out << "GL_MAX_EVAL_ORDER:             " << v[0] << std::endl;

	glGetIntegerv(GL_MAX_LIGHTS, v);
	out << "GL_MAX_LIGHTS:                 " << v[0] << std::endl;

	glGetIntegerv(GL_MAX_LIST_NESTING, v);
	out << "GL_MAX_LIST_NESTING:           " << v[0] << std::endl;

	glGetIntegerv(GL_MAX_MODELVIEW_STACK_DEPTH, v);
	out << "GL_MAX_MODELVIEW_STACK_DEPTH:  " << v[0] << std::endl;

	glGetIntegerv(GL_MAX_NAME_STACK_DEPTH, v);
	out << "GL_MAX_NAME_STACK_DEPTH:       " << v[0] << std::endl;

	glGetIntegerv(GL_MAX_PIXEL_MAP_TABLE, v);
	out << "GL_MAX_PIXEL_MAP_TABLE:        " << v[0] << std::endl;

	glGetIntegerv(GL_MAX_PROJECTION_STACK_DEPTH, v);
	out << "GL_MAX_PROJECTION_STACK_DEPTH: " << v[0] << std::endl;

	glGetIntegerv(GL_MAX_TEXTURE_SIZE, v);
	out << "GL_MAX_TEXTURE_SIZE:           " << v[0] << std::endl;

	glGetIntegerv(GL_MAX_TEXTURE_STACK_DEPTH, v);
	out << "GL_MAX_TEXTURE_STACK_DEPTH:    " << v[0] << std::endl;

	glGetIntegerv(GL_MAX_VIEWPORT_DIMS, v);
	out << "GL_MAX_VIEWPORT_DIMS:          " << v[0] << " " << v[1] << std::endl;


	glGetIntegerv(GL_SUBPIXEL_BITS, v);
	out << "GL_SUBPIXEL_BITS:              " << v[0] << std::endl;

	glGetFloatv(GL_POINT_SIZE_RANGE, fv);
	out << "GL_POINT_SIZE_RANGE:           " << fv[0] << " " << fv[1] << std::endl;

	glGetFloatv(GL_POINT_SIZE_GRANULARITY, fv);
	out << "GL_POINT_GRANULARITY:          " << fv[0] << std::endl;

	glGetFloatv(GL_LINE_WIDTH_RANGE, fv);
	out << "GL_LINE_WIDTH_RANGE:           " << fv[0] << " " << fv[1] << std::endl;

	glGetFloatv(GL_LINE_WIDTH_GRANULARITY, fv);
	out << "GL_LINE_WIDTH_GRANULARITY:     " << fv[0] << std::endl;
	out << std::endl;
	out << std::endl;
}


}
}
