#ifndef GL_KANJI_INCLUDE
#define GL_KANJI_INCLUDE

#include <vector>
#include <string>


namespace ist {
namespace i3d {


class Kanji
{
public:
	enum { SJIS, EUC, JIS };

	Kanji(int _code=SJIS);
	Kanji(const std::string& filename, int _code=SJIS);

	void print(int x, int y, const char *str);

	void setCode(int _code);
	int getFontSize();
	bool load(const std::string& filename);

protected:
	void init();
	const unsigned char* getChar(int index);

	int font_size;
	int char_byte;
	int max_index;
	int code;
	std::vector<unsigned char> data;

};


} //gl
} //ist

#endif
