#include "gl_include.h"
#include "i3d_material.h"


namespace ist {
namespace i3d {


Material::Material() :
	ambient(0.2f, 0.2f, 0.2f, 1.0f),
	diffuse(0.8f, 0.8f, 0.8f, 1.0f),
	specular(0.0f, 0.0f, 0.0f, 0.0f),
	emission(0.0f, 0.0f, 0.0f, 0.0f),
	shininess(60.0f)
{};

void Material::assign() const
{
	glMaterialfv(GL_FRONT, GL_AMBIENT,  ambient.v);
	glMaterialfv(GL_FRONT, GL_DIFFUSE,  diffuse.v);
	glMaterialfv(GL_FRONT, GL_SPECULAR, specular.v);
	glMaterialfv(GL_FRONT, GL_EMISSION, emission.v);
	glMaterialfv(GL_FRONT, GL_SHININESS,&shininess);
}


Color::Color() :
	color(1.0f, 1.0f, 1.0f, 1.0f)
{}

Color::Color(float r, float g, float b, float a) :
	color(r, g, b, a)
{}

void Color::assign() const
{
	glColor4fv(color.v);
}


} //gl
} //ist

