#ifndef I3D_TEXTURE_INCLUDE
#define I3D_TEXTURE_INCLUDE

#include <string>
#include "bitmap.h"


namespace ist {
namespace i3d {


class ITexture
{
public:
	static ITexture* create();


	virtual ~ITexture() {}

	virtual bool load(
		const std::string& filename,
		unsigned int cell_width=0,
		unsigned int cell_height=0) =0;

	virtual bool load(
		const Bitmap& src,
		unsigned int cell_width=0,
		unsigned int cell_height=0) =0;

	virtual void clear()=0;
	virtual void assign(int index=0) const =0;
	virtual bool operator !()  const=0;

	virtual unsigned int getNumCell() const=0;
	virtual void setDimension(int)=0;  // GL_TEXTURE_2D | GL_TEXTURE_1D
	virtual void setType(int)=0;       // GL_RGBA | GL_RGB | GL_ALPHA | GL_LUMINANCE
	virtual void setMagFilter(int)=0;  // GL_LINEAR | GL_NEAREST
	virtual void setMinFilter(int)=0;
	virtual void setWarpS(int)=0;      // GL_REPEAT | GL_CLAMP
	virtual void setWarpT(int)=0;
	virtual void setEnvMode(int)=0;    // GL_MODULATE | GL_DECAL | GL_REPLACE | GL_BLEND | GL_ADD
};





}	// i3d
}	// ist

#endif


